
' Don't look at this code! I had to look while writing it and
' will now stare into the abyss forever! Just run it in the same folder
' as hardwired.decls...

Strict

Type FunctionData

	Field mfunc$
	Field dllfunc$

	Field fname:String
	Field rtype:String
	Field mparams:String []
	
	Global FDList:TList

	Function AddFunction:FunctionData ()
		If FunctionData.FDList = Null Then FunctionData.FDList = CreateList ()
		Local fd:FunctionData = New FunctionData
		ListAddLast FunctionData.FDList, fd
		Return fd
	End Function

End Type

Const KEY_WORDS = 6

Global keyword$ [KEY_WORDS]

	keyword$ [0] = "global"
	keyword$ [1] = "type"
	keyword$ [2] = "max"
	keyword$ [3] = "min"
	keyword$ [4] = "string"
	keyword$ [5] = "method"

Function ReplaceMaxKeywords$ (mfunc$)

	Local firstbracket = Instr (mfunc$, "(")
	Local secondbracket = Instr (mfunc$, ")", firstbracket + 1)

	If (firstbracket > 0) And (secondbracket > 0)

		Local funcname$ = Left (mfunc$, firstbracket - 1)

		firstbracket = firstbracket + 1
		Local parameters$ = Mid (mfunc$, firstbracket, secondbracket - firstbracket)
		
		If parameters$ <> ""
			
			' Reconstructing mfunc$ only If it has parameters...
		
			mfunc$ = funcname$ + "("
	
			parameters$ = Trim (parameters$) ' Ditch any spaces/tabs that might creep in
			
			Local comma = Instr (parameters$, ",")
			
			Local param$
			Local tparam$

			While comma
			
				param$ = Left (parameters$, comma - 1)
	
				' Take out parameter Type For name-check...
				
				tparam$ = Replace (param$, "%", "")
				tparam$ = Replace (tparam$, "#", "")
				tparam$ = Replace (tparam$, "$", "")
			
				parameters$ = Mid (parameters$, comma + 1)
				
				For Local check = 0 To KEY_WORDS - 1
					If tparam$ = keyword$ [check]
						param$ = "_" + param$
					EndIf
				Next

				mfunc$ = mfunc$ + param$ + ","
				
				comma = Instr (parameters$, ",")
				
			Wend
			
			param$ = parameters$
	
			tparam$ = Replace (param$, "%", "")
			tparam$ = Replace (tparam$, "#", "")
			tparam$ = Replace (tparam$, "$", "")

			For Local check = 0 To KEY_WORDS - 1
				If tparam$ = keyword$ [check]
					param$ = "_" + param$
				EndIf
			Next

			mfunc$ = mfunc$ + param$ + ")"
			
		EndIf
		
	EndIf

	Return mfunc$
	
End Function

' -------------------------------------------------------
' Main program!
' -------------------------------------------------------

Local dll$ = ""

Local file:TStream = ReadFile ("hardwired.decls")

If file

	While Not Eof (file)
	
		Local bb$ = ReadLine (file)
		
		If bb$ <> ""
		
			Local firstquote
			Local secondquote
		
			' -----------------------------------------------------------------
			' Find DLL...
			' -----------------------------------------------------------------

			If Lower (Left (Trim (bb$), 4)) = ".lib" ' ADDED Trim!
				
				firstquote = Instr (bb$, Chr (34))
				
				firstquote = firstquote + 1 ' Get past first quote
				
				If firstquote
					secondquote = Instr (bb$, Chr (34), firstquote + 1)
					dll$ = Mid (bb$, firstquote, secondquote - firstquote)
					If dll$ = ""
						Print "No DLL found!"
						Exit
					EndIf
				Else
					Print "No DLL line!"
					Exit
				EndIf
			
			' -----------------------------------------------------------------
		
			Else
			
				' -------------------------------------------------------------	
				' Standard decl line...
				' -------------------------------------------------------------	
				
				' Basic structure:
				
				' Function | optional Return Type | opening bracket | params | closing bracket | colon | quoted real Function name


				' dxCountGfxDrivers%():"dCountGfxDrivers"
				
				' Find brackets:
				
				' 
				
				
				Local split = Instr (bb$, ":")
				
				Local mfunc$	= ""
				Local cppfunc$		= ""
				Local dllfunc$		= ""
				
				If split

					Local fd:FunctionData = FunctionData.AddFunction ()

					mfunc$ = Left (bb$, split - 1)

					mfunc$ = ReplaceMaxKeywords (mfunc$)
					
					mfunc$ = Replace (mfunc$, "%", ":Int")
					mfunc$ = Replace (mfunc$, "#", ":Float")
					mfunc$ = Replace (mfunc$, "$", ":CStringNative")

					'Print mfunc$
					
					' Break it down...

					' Function | optional Return Type | opening bracket | params | closing bracket | colon | quoted real Function name

					' dxAddVertex:Int(surface:Int,x:Float,y:Float,z:Float,u:Float,v:Float,w:Float)

					' Find brackets...
					
					' fd.param$ []
					
					Local firstbracket = Instr (mfunc$, "(")
					Local secondbracket = Instr (mfunc$, ")")
					
					If firstbracket And secondbracket And (firstbracket < secondbracket)
					
						' Get parameters...
						
						Local param$ = Mid (mfunc$, firstbracket + 1, secondbracket - (firstbracket + 1))
						
						fd.mparams = param.Split (",")
						
						Local pcount = 0
						
						For Local pr$ = EachIn fd.mparams

							pr$ = Trim (pr$)
							
							If pr$
								If Not Instr (pr$, ":") ' No type specified
									pr$ = pr$ + ":Int"
								EndIf
							EndIf
							
							fd.mparams [pcount] = pr$
							pcount = pcount + 1
							
						Next
					
						' Get function name/type...
						
						fd.fname = Trim (Left (mfunc$, firstbracket - 1))
						
						'Print fd.fname
						
						Local npsplit = Instr (fd.fname, ":")
						
						If npsplit
						
							fd.rtype = Trim (Mid (fd.fname, npsplit + 1))
							
							fd.fname = Trim (Left (fd.fname, npsplit - 1))
							
							'Print "~q" + fd.fname + "~q"
							
						Else
							fd.rtype = "Void" ' No type specified
						EndIf
						
					Else
						RuntimeError "Missing brackets in " + mfunc$ + "!"
					EndIf
					
					'cppfunc$
					
'					If mfunc$ <> ""
'						fd.mfunc$ = mfunc$
'					EndIf

					dllfunc$ = Mid (bb$, split + 1)

'					firstquote = Instr (dllfunc$, Chr (34))
					
'					firstquote = firstquote + 1 ' Get past first quote
					
'					If firstquote
					
'						secondquote = Instr (dllfunc$, Chr (34), firstquote + 1)
						
'						dllfunc$ = Mid (dllfunc$, firstquote, secondquote - firstquote)

'						If dllfunc$ <> ""
'							fd.dllfunc$ = dllfunc$
'						EndIf
	
'					Else
'						Print "No quoted DLL function!"
'						Exit
'					EndIf
					
				Else
					Print "Not taken lines without colons into account! Doh!"
					Exit
				EndIf
				
			EndIf

		EndIf
	
	Wend
	
	CloseFile file
	
EndIf

'For Local fd:FunctionData = EachIn FunctionData.FDList

'	Print fd.fname$
'	If fd.rtype Then Print fd.rtype
	
'	For Local p$ = EachIn (fd.mparams)
'		If p$ = ""
'			p$ = "[Void]"
'		EndIf
'		Print "~t" + p$
'	Next

'	Print ""
	
'Next

'End

Local cppfile:TStream = WriteFile ("hardwiredlib.cpp")
Local mnkfile:TStream = WriteFile ("hardwired.monkey")

If cppfile And mnkfile

	Local dllhandle$ = "HW_DLL"
	
	WriteLine cppfile, ""
	WriteLine cppfile, "#define VC_EXTRALEAN"
	WriteLine cppfile, "#define WIN32_LEAN_AND_MEAN"
	WriteLine cppfile, "#include <windows.h>"
	WriteLine cppfile, ""
	WriteLine cppfile, "#define BBDECL extern " + Chr (34) + "C" + Chr (34)
	WriteLine cppfile, "#include <iostream>"
	WriteLine cppfile, ""
	WriteLine cppfile, "using namespace std; // Temp"
	WriteLine cppfile, ""
	WriteLine cppfile, "HINSTANCE " + dllhandle + ";"
	WriteLine cppfile, ""

	WriteLine mnkfile, ""
	WriteLine mnkfile, "Import ~qhardwiredlib.cpp~q"
	WriteLine mnkfile, ""
	WriteLine mnkfile, "Extern"
	WriteLine mnkfile, ""
	WriteLine mnkfile, "~t' Wrapper functions..."
	WriteLine mnkfile, ""
	WriteLine mnkfile, "~tFunction InitDLL:Int ()"
	WriteLine mnkfile, "~tFunction FreeDLL:Void ()"
	WriteLine mnkfile, ""
	WriteLine mnkfile, "~t' C-string hack by Pharmhaus!"
	WriteLine mnkfile, ""
	WriteLine mnkfile, "~tFunction NativeCString:CStringNative(S:String)"
	WriteLine mnkfile, "~t~tClass CStringNative Abstract"
	WriteLine mnkfile, "~tEnd"
	WriteLine mnkfile, ""
	WriteLine mnkfile, "~t' Hardwired functions..."
	WriteLine mnkfile, ""

	Local funclist:TList = CreateList ()
	
	For Local fd:FunctionData = EachIn FunctionData.FDList

'		Print fd.mfunc$
		
		' WriteLine cppfile, "Function " + fd.mfunc$ + " " + Chr (34) + "win32" + Chr (34)
		
		'Function dxCountGfxDrivers:Int() "win32"
		'BBDECL typedef int (__stdcall *LPMSGBOX)(HWND hWnd, LPCTSTR lpText, LPCTSTR lpCaption, UINT uType)'
		
		Local rtype:String = ""
		
		Select fd.rtype
			Case "", "Void"
				rtype = "void"
			Case "Int"
				rtype = "int"
			Case "Float"
				rtype = "float"
			Case "CStringNative"
				rtype = "LPCTSTR"
			Default
				RuntimeError "Unimplemented type: " + fd.rtype
		End Select
		
		Local param$ = " "
		Local strparam = 0
		
		For Local p$ = EachIn (fd.mparams)
			If p$ = ""
				p$ = "void"
			Else

				Local split = Instr (p$, ":")

				If split

					Local ptype$ = Mid (p$, split + 1)
					
					Select ptype
						Case ""', "Void"
							ptype = "void"
						Case "Int"
							ptype = "int"
						Case "Float"
							ptype = "float"
						Case "CStringNative"
							ptype = "LPCTSTR"
							strparam = 1
						Default
							RuntimeError "Unimplemented type: " + ptype
					End Select
				
					param$ = param$ + ptype + " "
					param$ = param$ + Left (p$, split - 1) + ","

				EndIf

			EndIf

		Next
		
		param$ = Left (param$, Len (param$) - 1) + " " ' - last comma + space

		Local dllfunc$ = fd.fname
		
		If Left (dllfunc$, 2) = "dx"
			dllfunc$ = "d" + Mid (dllfunc$, 3)
		EndIf

		Local functype$ = "LP" + Upper (dllfunc$)
		Local cline$ = "BBDECL typedef " + rtype + " (__stdcall *" + functype$ + ")(" + param$ + ");"
		
		' TODO: If strparam... rename function and add wrapper!
		
		WriteLine cppfile, cline$

		param$ = ""
		
		For Local p$ = EachIn (fd.mparams)
			param$ = param$ + p$ + ", "
		Next
		
		param$ = Left (param$, Len (param$) - 2) ' Strip last ", "
		
		Local mline$ = "~tFunction " + fd.fname + ":" + fd.rtype + " (" + param$ + ")"
		
		WriteLine mnkfile, mline$
		
	Next
	
	WriteLine cppfile, ""
	WriteLine mnkfile, ""
	
	For Local fd:FunctionData = EachIn FunctionData.FDList

		Local dllfunc$ = fd.fname
		
		If Left (dllfunc$, 2) = "dx"
			dllfunc$ = "d" + Mid (dllfunc$, 3)
		EndIf

		WriteLine cppfile, "LP" + Upper (dllfunc$) + " " + fd.fname + ";"

	Next
	
	WriteLine cppfile, ""

	WriteLine cppfile, "BBDECL int InitDLL ()"
	WriteLine cppfile, "{"
	WriteLine cppfile, dllhandle + " = LoadLibrary (~qHardwired.dll~q);"
	WriteLine cppfile, ""
	WriteLine cppfile, "if (" + dllhandle + " != NULL)"
	WriteLine cppfile, "~t{"
	
	' List of functions...
	
	For Local fd:FunctionData = EachIn FunctionData.FDList
		
		Local dllfunc$ = fd.fname
		
		If Left (dllfunc$, 2) = "dx"
			dllfunc$ = "d" + Mid (dllfunc$, 3)
		EndIf
		
		WriteLine cppfile, "~t~t" + fd.fname + " = (LP" + Upper (dllfunc$) + ")GetProcAddress ((HMODULE)" + dllhandle + ", ~q" + dllfunc$ + "~q);"
		
		WriteLine cppfile, ""
		WriteLine cppfile, "~t~tif (" + fd.fname + " == NULL)"
		WriteLine cppfile, "~t~t{"
		WriteLine cppfile, "~t~t~tcout << ~qFunction " + fd.fname + " (\~q" + dllfunc$ + "\~q) not found in DLL!\n~q;"
		WriteLine cppfile, "~t~t}"
		WriteLine cppfile, ""

	Next
	
	WriteLine cppfile, "~t~treturn 1;"
	WriteLine cppfile, "~t}"
	WriteLine cppfile, "}"

	WriteLine cppfile, ""
	WriteLine cppfile, "BBDECL void FreeDLL ()"
	WriteLine cppfile, "{"
	WriteLine cppfile, "~tif (" + dllhandle + " != NULL)"
	WriteLine cppfile, "~t{"
	WriteLine cppfile, "~t~tFreeLibrary (" + dllhandle + ");"
	WriteLine cppfile, "~t}"
	WriteLine cppfile, "}"

	WriteLine cppfile, ""
	WriteLine cppfile, "String::CString<char> NativeCString(const String & S)"
	WriteLine cppfile, "{"
	WriteLine cppfile, "~treturn S.ToCString<char>();"
	WriteLine cppfile, "}"

	WriteLine mnkfile, "Public"

	CloseFile cppfile
	CloseFile mnkfile

Else
	If Not cppfile Print "Failed to write to C++ file!"
	If Not mnkfile Print "Failed to write to Monkey file!"
EndIf

Print "BlitzMax conversion done!"
End
